package moca.core.proxy.actions.adapters;

/**
 * Classe base para erros durante o processo de adaptao de mensagens.
 * @author hana
 */
public class AdaptationException extends Exception {
	/**
	 * 
	 */
	private static final long serialVersionUID = -1249756845753483749L;
	/**
	* Exceo com fornecimento de mensagem de erro
	* @param msg texto provavelmente descrevendo a causa da exceo
	*/
	public AdaptationException(String msg) {
		super(msg);
	}
	/**
	 * Permite aninhamento de objetos throwable ("arremessveis").
	 * @param throwable objeto throwable aninhado
	 */
	public AdaptationException(Throwable throwable) {
		super(throwable);
	}
	/**
	 * Permite aninhamento de objetos throwable e fornecimento de mensagem
	 * @param msg mensagem explicativa sobre a exception
	 * @param cause causa da exceo
	 */
	public AdaptationException(String msg, Throwable cause) {
			super(msg, cause);

	}
}
