/*
 * Created on 28/11/2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package moca.core.proxy.development;

import moca.core.proxy.communication.CommunicationProtocol;
import moca.util.eci.Subscription;



/**
 * Enables the aplication being informed when a subscription from a client is received. This way, 
 * always that a subscriber is registered as interested in some event, or it unregister
 * its interest (unsubcride) the aplication may be notified. 
 * 
 * @author Hana
 */
public interface SubscribeListener
{
	/**
	 * The listener method. Its called when the publisher receives 
	 * a subscription and inform this to the proxy application
	 * 
	 * <p>
	 * Use the method {@link moca.protocol.pubsub.Subscription#isSubscribe()} to know if it 
	 * is a subscribe request or not(i.e an unsubscribe request).
	 * 
	 * @param data A subscription. 
	 * @param protocol - The communication protocol used by the client
	 */
	abstract public void onReceiveSubscription(Subscription data,CommunicationProtocol protocol);		
}
